services:
  proxy:
    image: registry.gitlab.com/sat-polsl/gcs/gcs-proxy:latest
    restart: always
    ports:
      - "14789:14789"
      - "14790:14790"
    environment:
      PUB_PORT: 14789
      SUB_PORT: 14790

  transceiver:
    image: registry.gitlab.com/sat-polsl/gcs/gcs-transceiver:latest
    restart: always
    init: true
    volumes:
      - ./transceiver-config.yaml:/transceiver-config.yaml
    environment:
      PROXY_IP: proxy
      PUB_PORT: 14789
      SUB_PORT: 14790
      LOG_ARGS: --debug
      CONFIG_FILE: /transceiver-config.yaml
    depends_on:
      - transceiver

  jaeger-all-in-one:
    image: docker.io/jaegertracing/all-in-one:latest
    restart: always
    ports:
      - "16686:16686"
      - "14268:14268"
      - "14250:14250"

  otel-collector:
    image: docker.io/otel/opentelemetry-collector:0.67.0
    restart: always
    command: [ "--config=/etc/otel-collector-config.yaml" ]
    volumes:
      - ./otel-collector-config.yaml:/etc/otel-collector-config.yaml
    ports:
      - "1888:1888"   # pprof extension
      - "8888:8888"   # Prometheus metrics exposed by the collector
      - "8889:8889"   # Prometheus exporter metrics
      - "13133:13133" # health_check extension
      - "4317:4317"   # OTLP gRPC receiver
      - "55679:55679" # zpages extension
    depends_on:
      - jaeger-all-in-one
      - prometheus

  prometheus:
    image: prom/prometheus:latest
    restart: always
    command:
      - "--config.file=/etc/prometheus/prometheus.yml"
      - "--storage.tsdb.path=/prometheus"
      - "--web.console.libraries=/usr/share/prometheus/console_libraries"
      - "--web.console.templates=/usr/share/prometheus/consoles"
    volumes:
      - ./prometheus.yml:/etc/prometheus/prometheus.yml
    ports:
      - 9090:9090

  postgres:
    image: postgres:latest
    restart: always
    environment:
      POSTGRES_USER: user
      POSTGRES_PASSWORD: Passw0rd+
      POSTGRES_DB: database
    ports:
      - "5432:5432"
